<?php

namespace app\admin\controller;

use app\BaseController;
use think\App;
use think\facade\Db;

class Activity extends BaseController
{
    public $post="";
    public function __construct(App $app)
    {
        parent::__construct($app);
        $this->post=$this->request->post();
    }
    public function list(){
        $page = isset($this->post['page']) && $this->post['page'] !==""? intval($this->post['page']):"1";
        $size = isset($this->post['size']) && $this->post['size'] !==""? intval($this->post['size']):"10";
        $where = [["is_del","=",0]];
        $activity_name = isset($this->post['activity_name']) && $this->post['activity_name'] !=="" ? trim($this->post['activity_name']):"";
        if($activity_name!=""){
            $where[]=['activity_name',"like","%$activity_name%"];
        }
        $status = isset($this->post['status']) && $this->post['status'] !=="" ? intval($this->post['status']):"";
        if($status!=""){
            $where[]=['status',"=",$status];
        }
        $activity_code = isset($this->post['activity_code']) && $this->post['activity_code'] !=="" ? intval($this->post['activity_code']):"";
        if($activity_code!=""){
            $where[]=['activity_code',"like","%$activity_code%"];
        }
        $starttime = isset($this->post['starttime']) && $this->post['starttime']!=="" ? $this->post['starttime']:"";
        if($starttime!==""){
            $where[]=['starttime',">=",date('Y-m-d H:i:s',strtotime($starttime))];
        }
        $endtime = isset($this->post['endtime']) && $this->post['endtime']!=="" ? $this->post['endtime']:"";
        if($endtime!==""){
            $where[]=['endtime',"<",date('Y-m-d H:i:s',strtotime($endtime)+24*3600)];
        }
        $platform_code = isset($this->post['platform_code']) && $this->post['platform_code'] !=="" ? trim($this->post['platform_code']):"";
        if($platform_code!=""){
            $where[]=['platform_code',"=",$platform_code];
        }

        $count = Db::name('good_activity')->where($where)->count();
        $total = ceil($count / $size);
        $page = $page >= $total ? $total : $page;
        $list = Db::name('good_activity')->where($where)->page($page,$size)->order("addtime desc")->select();
        $data=[];
        foreach ($list as $value){
            $info = Db::name("platform")->where(['platform_code'=>$value['platform_code']])->find();
            $value['platform_name']=$info['platform_name'];
            $data[]=$value;
        }
        return app_show(0,"获取成功",['list'=>$data,'count'=>$count]);
    }
    public function linst()
    {
        $page = isset($this->post['page']) && $this->post['page'] !== "" ? intval($this->post['page']) : "1";
        $size = isset($this->post['size']) && $this->post['size'] !== "" ? intval($this->post['size']) : "10";
        $where = [["a.is_del", "=", 0]];
        $spuCode = isset($this->post['spuCode']) && $this->post['spuCode'] !== "" ? trim($this->post['spuCode']) : "";
        if ($spuCode != "") {
            $where[] = ['a.spuCode', "like", "%$spuCode%"];
        }
        $good_name = isset($this->post['good_name']) && $this->post['good_name'] !== "" ? trim($this->post['good_name']) : "";
        if ($good_name != "") {
            $where[] = ['a.good_name', "like", "%$good_name%"];
        }
        $activity_code = isset($this->post['activity_code']) && $this->post['activity_code'] !=="" ? intval($this->post['activity_code']):"";
        if($activity_code!=""){
            $where[]=['a.activity_code',"like","%$activity_code%"];
        }
        $status = isset($this->post['status']) && $this->post['status'] !=="" ? intval($this->post['status']):"";
        if($status!=""){
            $where[]=['a.status',"=",$status];
        }
        $activity_name = isset($this->post['activity_name']) && $this->post['activity_name'] !=="" ? trim($this->post['activity_name']):"";
        if($activity_name!=""){
            $where[]=['b.activity_name',"like","%$activity_name%"];
        }
        $platform_code = isset($this->post['platform_code']) && $this->post['platform_code'] !=="" ? trim($this->post['platform_code']):"";
        if($platform_code!=""){
            $where[]=['c.platform_code',"=",$platform_code];
        }
        $count = Db::name('activity_info')->alias("a")
            ->join("good_activity b","b.activity_code=b.activity_code","left")
            ->join("platform c","c.platform_code=b.platform_code","left")
            ->where($where)->count();
        $total = ceil($count / $size);
        $page = $page >= $total ? $total : $page;
        $list = Db::name('activity_info')->alias("a")
            ->join("good_activity b","b.activity_code=b.activity_code","left")
            ->join("platform c","c.platform_code=b.platform_code","left")
            ->where($where)->page($page,$size)->order("a.addtime desc")->field("a.*,b.activity_name,c.platform_name")->select();
        return app_show(0,"获取成功",['list'=>$list,'count'=>$count]);
    }
    public function zilist(){
        $page = isset($this->post['page']) && $this->post['page'] !== "" ? intval($this->post['page']) : "1";
        $size = isset($this->post['size']) && $this->post['size'] !== "" ? intval($this->post['size']) : "10";
        $where = [["a.is_del", "=", 0]];
        $good_code = isset($this->post['good_code']) && $this->post['good_code'] !== "" ? trim($this->post['good_code']) : "";
        if ($good_code != "") {
            $where[] = ['a.good_code', "like", "%$good_code%"];
        }
        $good_name = isset($this->post['good_name']) && $this->post['good_name'] !== "" ? trim($this->post['good_name']) : "";
        if ($good_name != "") {
            $where[] = ['a.good_name', "like", "%$good_name%"];
        }

        $status = isset($this->post['status']) && $this->post['status'] !=="" ? intval($this->post['status']):"";
        if($status!=""){
            $where[]=['a.status',"=",$status];
        }
        $supplierNo = isset($this->post['supplierNo']) && $this->post['supplierNo'] !== "" ? trim($this->post['supplierNo']) : "";
        if ($supplierNo != "") {
            $where[] = ['a.supplierNo', "like", "%$supplierNo%"];
        }
        $name = isset($this->post['name']) && $this->post['name'] !== "" ? trim($this->post['name']) : "";
        if ($name != "") {
            $where[] = ['b.name', "like", "%$name%"];
        }
        $count = Db::name('good_zixun')->alias("a")->join("supplier b","b.code=a.supplierNo","left")
            ->where($where)->count();
        $total = ceil($count / $size);
        $page = $page >= $total ? $total : $page;
        $list = Db::name('good_zixun')->alias("a")->join("supplier b","b.code=a.supplierNo","left")
            ->where($where)->page($page,$size)->order("a.addtime desc")->field("a.*,b.name")->select();
        return app_show(0,"获取成功",['list'=>$list,'count'=>$count]);
    }
}